//
//  ColorPickerSubView.swift
//  ColorPicker
//
//  Created by Akira Hayashi on 2022/09/21.
//

import SwiftUI

struct ColorPickerSubView: View {
    var channel: ColorPickerModel.Channel
    @ObservedObject var model: ColorPickerModel
    
    var channelName: String {
        switch channel {
        case .red:
            return "Red"
        case .green:
            return "Green"
        case .blue:
            return "Blue"
        }
    }
    
    var fieldText: Binding<String> {
        switch self.channel {
        case .red:
            return self.model.fieldTextRed
        case .green:
            return self.model.fieldTextGreen
        case .blue:
            return self.model.fieldTextBlue
        }
    }
    
    var body: some View {
        VStack {
            HStack {
                Text("\(channelName): ")
                    .font(.title)
                TextField("", text: fieldText)
                    .textFieldStyle(.roundedBorder)
            }
            PickerGradationView(channel: channel, model: model)
        }
    }
}

struct ColorPickerSubView_Previews: PreviewProvider {
    static var previews: some View {
        ColorPickerSubView(channel: .red, model: ColorPickerModel())
            .padding()
    }
}
